function NeverFormInverse()

% Reason #1 You may run out of memory.
close all
n = 20;
% Here is a random tridiagonal matrix
A = tril(triu(randn(n,n),-1),1); 
Ainv = inv(A);
subplot(1,2,1)
spy(A)
title('A tridiagonal matrix...','fontsize',16)
subplot(1,2,2)
spy(Ainv)
title('It''s inverse...','fontsize',16)
shg

% Reason #2  Extra work...
clc
nRepeat = 100;
fprintf('  n   tInv/tLU\n----------------------\n')
for n=100:100:500
    A = randn(n,n);
    b = randn(n,1000);
    tic
    for k=1:nRepeat
       x = inv(A)*b;
    end
    tInv = toc;
    tic
    for k=1:nRepeat
       [L,U,p] = lu(A,'vector');
       x = U\(L\b(p,:));
    end
    tLU = toc;
    fprintf('%5d   %5.3f\n',n,tInv/tLU)
end
